VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00404080&
   Caption         =   "Form1"
   ClientHeight    =   10920
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11310
   LinkTopic       =   "Form1"
   ScaleHeight     =   10920
   ScaleWidth      =   11310
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const FRAMERATE = 60
Const GAME_WIDTH = 512
Const GAME_HEIGHT = 512

Const CHAR_TEX = 10
Const CHAR_WIDTH = 32
Const CHAR_HEIGHT = 32
Const CHAR_MOVEMENT_SPEED = 5

Const GRASS_WIDTH = 32
Const GRASS_HEIGHT = 32

Const CLOUD_WIDTH = 32
Const CLOUD_HEIGHT = 32

Dim Engine As DBTurbo2DEngine
Dim bExit As Boolean, BallSpec As Integer, BallDest As Integer

Private Sub Form_Load()
  
  Me.Show
  
  Set Engine = New DBTurbo2DEngine
  
  With Engine
    .InitializeDisplay Me.hWnd, True, GAME_WIDTH, GAME_HEIGHT
    .SetMaxLevel 5
  End With
  
  Engine.DBFPS.SetFrameRate FRAMERATE
  
  Engine.SetUpMapView 0, 0, GAME_WIDTH, GAME_HEIGHT, 0
  
  With Engine.DBKeyInput
    .Initialize Me.hWnd
    .Add DIK_ESCAPE
    .Add DIK_LEFT
    .SetAutoFire 2, True
    .Add DIK_RIGHT
    .SetAutoFire 3, True
    .Add DIK_UP
    .SetAutoFire 4, True
    .Add DIK_DOWN
    .SetAutoFire 5, True
  End With
  
  With Engine.DBSound
    .Initialize Me.hWnd
    .SetSoundFolder App.Path & "/Sfx/"
    .Add "beep1"
    .SetUpDirectionalSound 100, GAME_WIDTH, 10
  End With
  
  With Engine.DBTexture
    .SetFolder App.Path & "/Gfx/"
    .Add 512, "2tiles", , 2
    .Add 512 'UNUSED!
    .Add 512
    .Add 256
    .Add 512
    .Add 512
    .Add 512
    .Add 512
    .Add 512
    'Set colorkey to black
    .SetColorKeyBlue 0
    .SetColorKeyGreen 0
    .SetColorKeyRed 0
    .Add 128, "char", , 2
  End With
  
  SetUpGrass 3, App.Path & "\map1.txt"
  SetUpGrass 5, App.Path & "\map2.txt"
  'Engine.DBTexture.CopyRegion 3, 5, 0, 0, 0, 0, 512, 512
  Engine.DBTexture.CopyRegion 5, 6, 0, 0, 0, 0, 512, 512
  Engine.DBTexture.CopyRegion 5, 7, 0, 0, 0, 0, 512, 512
  SetUpGrass 8, App.Path & "\2map1.txt"
  
  SetUpClouds
  
  'SetUpEmptyMap
  
  With Engine.DBMap
    'Map 1 - Grass
    .SetXCount 1, 2
    .SetYCount 1, 2
    .SetLooping 1, False
    .SetSubMapWidth 1, GAME_WIDTH
    .SetSubMapHeight 1, GAME_HEIGHT
    .SetVisible 1, True
    .SetXIncrement 1, CHAR_MOVEMENT_SPEED
    .SetYIncrement 1, CHAR_MOVEMENT_SPEED
    .SetXReference 1, 2
    .SetYReference 1, 2
    .SetZOrder 1, 0
    'Map 2 - Objects etc.
    .SetXCount 2, 2
    .SetYCount 2, 2
    .SetLooping 2, False
    .SetSubMapWidth 2, GAME_WIDTH
    .SetSubMapHeight 2, GAME_HEIGHT
    .SetXIncrement 2, CHAR_MOVEMENT_SPEED
    .SetYIncrement 2, CHAR_MOVEMENT_SPEED
    .SetZOrder 2, 1
    .SetVisible 2, True
    'Map 2 - Clouds etc.
    .SetXCount 3, 2
    .SetYCount 3, 2
    .SetLooping 3, True
    .SetSubMapWidth 3, GAME_WIDTH / 2
    .SetSubMapHeight 3, GAME_HEIGHT / 2
    .SetXReference 3, 2
    .SetYReference 3, 2
    .SetXIncrement 3, CHAR_MOVEMENT_SPEED / 8
    .SetYIncrement 3, CHAR_MOVEMENT_SPEED / 8
    .SetZOrder 3, Engine.GetMaxLevel
    .QMSetAlpha 3, 200
    .SetVisible 3, True 'False for INVISIBLE!!!
  End With
  
  'Set up submaps
  With Engine.DBSubMap
    'Map 1 - Grass
    .SetTextureReference 1, 1, 1, 3
    .SetTextureReference 1, 2, 1, 5
    .SetTextureReference 1, 1, 2, 6
    .SetTextureReference 1, 2, 2, 7
    'Map 2 - Other
    .SetTextureReference 2, 1, 1, 8
    .SetTextureReference 2, 1, 2, 9
    .SetTextureReference 2, 2, 1, 9
    .SetTextureReference 2, 2, 2, 9
    'Map 3 - Clouds
    .SetTextureReference 3, 1, 1, 4
    .SetTextureReference 3, 2, 1, 4
    .SetTextureReference 3, 1, 2, 4
    .SetTextureReference 3, 2, 2, 4
    'map 2 - Map Limits
    .QMSetLimit 2, 1, 1, True, True, False, False
    .QMSetLimit 2, 2, 1, True, False, False, True
    .QMSetLimit 2, 1, 2, False, True, True, False
    .QMSetLimit 2, 2, 2, False, False, True, True
  End With
  
  'Set up auto move
  With Engine.DBAutoMove
    .SetOn True
    .SetMapReference 2
    .SetSpriteReference 1
    .SetWidth CHAR_WIDTH
    .SetHeight CHAR_HEIGHT
    .SetSWidth CHAR_WIDTH '* 4
    .SetSHeight CHAR_HEIGHT '* 4
  End With
  
  With Engine.DBText
    .CreateFont "ArialBlack", 16
    .Add
    .SetZOrder 1, 5
    .SetText 1, "Scrolling game test"
    .SetAlpha 1, 200
    .QMSetPutRectangle 1, 0, 0, 300, 30
    .Add
    .QMSetPutRectangle 2, 0, .GetHeight(1), 120, 30
    .SetZOrder 2, 5
  End With
  
  With Engine.DBSprite
    .Add
    .SetTextureReference 1, CHAR_TEX
    .SetMapReference 1, 2
    .SetXPosition 1, GAME_WIDTH / 2
    .SetYPosition 1, GAME_HEIGHT / 2
    .QMSetPutRectangle 1, -CHAR_WIDTH / 2, -CHAR_HEIGHT / 2, CHAR_WIDTH, CHAR_HEIGHT
    .QMSetGetRectangle 1, 0, 64, CHAR_WIDTH, CHAR_HEIGHT
    .SetZOrder 1, 2
    .SetVisible 1, True
  End With
  
  'Engine.DBMath.SetMaptoSprite
  
  Dim ix As Integer, iy As Integer
  
  For ix = 1 To Engine.DBMap.GetXCount(3)
    For iy = 1 To Engine.DBMap.GetYCount(3)
      'Engine.DBSubMap.QMSetAlpha 3, ix, iy, 100
      
      If iy = 1 Then
        Engine.DBSubMap.SetLLAlpha 3, ix, iy, 0 '(.DBSprite.GetYPosition(1) / GAME_HEIGHT) * 100
        Engine.DBSubMap.SetLRAlpha 3, ix, iy, 0 '(.DBSprite.GetXPosition(1) / GAME_WIDTH) * 100
      ElseIf iy = 2 Then
        Engine.DBSubMap.SetULAlpha 3, ix, iy, 0 '(.DBSprite.GetYPosition(1) / GAME_HEIGHT) * 100
        Engine.DBSubMap.SetURAlpha 3, ix, iy, 0 '(.DBSprite.GetXPosition(1) / GAME_WIDTH) * 100
      End If
      
      If ix = 1 Then
        Engine.DBSubMap.SetURAlpha 3, ix, iy, 0
        Engine.DBSubMap.SetLRAlpha 3, ix, iy, 0
      ElseIf ix = 2 Then
        Engine.DBSubMap.SetULAlpha 3, ix, iy, 0
        Engine.DBSubMap.SetLLAlpha 3, ix, iy, 0
      End If
    Next iy
  Next ix
  
  Do Until bExit = True
    With Engine
    
      .DBKeyInput.PollKeyBoard
      
      If .DBKeyInput.ReturnKeyDown(1) = True Then bExit = True
      
      If .DBKeyInput.ReturnKeyDown(2) = True Then
        .DBMath.SpriteIncrementLeft 1, CHAR_MOVEMENT_SPEED
      End If
      If .DBKeyInput.ReturnKeyDown(3) = True Then
        .DBMath.SpriteIncrementRight 1, CHAR_MOVEMENT_SPEED
      End If
      If .DBKeyInput.ReturnKeyDown(4) = True Then
        .DBMath.SpriteIncrementUp 1, CHAR_MOVEMENT_SPEED
      End If
      If .DBKeyInput.ReturnKeyDown(5) = True Then
        .DBMath.SpriteIncrementDown 1, CHAR_MOVEMENT_SPEED
      End If
            
      .Render
      
      .DBText.SetText 2, .DBFPS.GetFPS & " FPS"
    End With
    DoEvents
  Loop
  
  Unload Me
  End
  
End Sub

Private Sub SetUpGrass(DestIndex As Integer, FilePath As String)

  Dim FileNum As Integer, XTiles() As String, YRowNum As Integer
  FileNum = FileSystem.FreeFile
  'dim FilePath As String
  'FilePath = App.Path & "\map.txt"
  YRowNum = 0

  Open FilePath For Input As #FileNum

  Do Until EOF(FileNum) = True
    ReDim Preserve XTiles(YRowNum)
    Input #FileNum, XTiles(YRowNum)
    YRowNum = YRowNum + 1
  Loop

  Close FileNum
  
  'Loop to every 16th position on texture and blit the according water to it.
  Dim X As Single, Y As Single
  For Y = 0 To (GAME_HEIGHT - GRASS_HEIGHT) Step GRASS_HEIGHT
    For X = 0 To (GAME_WIDTH - GRASS_WIDTH) Step GRASS_WIDTH
      'Engine.DBTexture.CopyRegion 1, 2, 128, 0, X, Y, GRASS_WIDTH, GRASS_HEIGHT
      'Engine.DBTexture.CopyRegion 1, 2, X, 32 * Int(Rnd * 8), X, Y, GRASS_WIDTH, GRASS_HEIGHT
      'Debug.Print Int(Mid(XTiles(Y / GRASS_WIDTH), X / GRASS_HEIGHT + 1, 1)) * GRASS_WIDTH
      If Mid(XTiles(Y / GRASS_WIDTH), X / GRASS_HEIGHT + 1, 1) = "-" Then
      
      Else
        Engine.DBTexture.CopyRegion 1, DestIndex, Int(Mid(XTiles(Y / GRASS_WIDTH), X / GRASS_HEIGHT + 1, 1)) * GRASS_WIDTH, 0, X, Y, GRASS_WIDTH, GRASS_HEIGHT
      End If
    Next X
  Next Y

End Sub

Private Sub SetUpClouds()

  'Loop to every 16th position on texture and blit the according water to it.
  Dim X As Single, Y As Single
  For Y = 0 To (GAME_HEIGHT / 2 - CLOUD_HEIGHT) Step CLOUD_HEIGHT
    For X = 0 To (GAME_WIDTH / 2 - CLOUD_WIDTH) Step CLOUD_WIDTH
      Engine.DBTexture.CopyRegion 1, 4, 64, 384, X, Y, CLOUD_WIDTH, CLOUD_HEIGHT
    Next X
  Next Y

End Sub

'Private Sub SetUpEmptyMap()
'
'  Dim X As Single, Y As Single
'  For Y = 0 To (GAME_HEIGHT / 2 - GRASS_HEIGHT) Step GRASS_HEIGHT
'    For X = 0 To (GAME_WIDTH / 2 - GRASS_WIDTH) Step GRASS_WIDTH
'      Engine.DBTexture.CopyRegion 2, 4, 64, 128, X, Y, GRASS_WIDTH, GRASS_HEIGHT
'    Next X
'  Next Y
'
'End Sub

'Public Sub GetTextureByIndex(Index As Integer, X As Single, Y As Single, Width As Single, Height As Single, GWidth As Single, GHeight As Single, Position As Integer)
'
'  Dim XCount As Single, YCount As Single, TSize As Single, GIndex As Single
'
'  TSize = TextureInfo(Sprite(Index).TRef).Size
'  GIndex = Position - 1
'  XCount = Width / GWidth
'  YCount = Height / GHeight
'
'  Dim GX As Single, GY As Single
'  GY = Int(GIndex / YCount)
'  GX = GIndex - (GY * YCount)
'
'  With Sprite(Index)
'    .Get.X = X + GX * GWidth
'    .Get.Y = Y + GY * GHeight
'    .Get.Width = GWidth
'    .Get.Height = GHeight
'
'    If .XMirror = False Then
'      .Tx1 = TextureValue(TSize, .Get.X)
'      .Tx2 = TextureValue(TSize, .Get.X + .Get.Width)
'    Else
'      .Tx1 = TextureValue(TSize, .Get.X + .Get.Width)
'      .Tx2 = TextureValue(TSize, .Get.X)
'    End If
'    If .YMirror = False Then
'      .Ty1 = TextureValue(TSize, .Get.Y)
'      .Ty2 = TextureValue(TSize, .Get.Y + .Get.Height)
'    Else
'      .Ty1 = TextureValue(TSize, .Get.Y + .Get.Height)
'      .Ty2 = TextureValue(TSize, .Get.Y)
'    End If
'  End With
'
'End Sub

Private Sub Form_Unload(Cancel As Integer)
  Cancel = 0
  bExit = True
End Sub
